.TH ag_c 1 "TACOMA 1.2" "Agents"
.SH NAME
ag_c \- agent which compiles and executes c code
.SH DESCRIPTION
The ag_c agent compiles the C code found in all the folders
named in the CCODE folder list. This folder \fBmust\fR
exist and the list should be terminated with an empty item. The folder names
specified in CCODE will be used as filenames when the contents of the
corresponding folders are saved to disk. So folder names like
\fCgui.c\fR, \fCgui.h\fR, and \fCdeep.c\fR should be used. 

Ag_c then rotates CMAIN to determine which procedure to call. If CMAIN
is empty or non-existent, a c procedure called 'Main' will
be called by default. This procedure is called with the supplied
\fIbriefcase\fR as it's first and only argument.

Ag_C compiles the agents by issuing a call to the compiler configured
in \fC$TACOMAPATH/cabinets/C_files/COMPILE\fR. This file is usually
created when TACOMA is first installed. See below for the
template syntax if you need to change it.
.SS Note
It is quite legal to specify a non-existing \fIfolder\fR in the
CCODE list, but at least one folder must exist. This
is the folder containing the main procedure to be called. This
behavior allows the application programmer to drop (delete) code
folders as the agent travels in order to reduce the size of the
briefcase.
.SS Folder inputs
.TP
CCODE
a folder containing a list of folder names each containing
C code to be evaluated before calling the main
procedure.
.TP
CMAIN
a list of procedures. The first procedure named on this
list will be called at this site. Since this folder
is rotated, it could contain a predefined list of
procedures to call at different sites. However if the
same procedure should be called at each site, this
folder should contain only the name of that procedure.
.SH FILES
.TP
$TACOMAPATH/cabinets/C_files/COMPILE
This file should
contain the template of a call to the compiler. The 
keyword '\fC%c\fR'
is replaced with all files (folders) prefixed with '.c'. 
Keywords '\fC%l\fR' and '\fC%i\fR' are 
replaced with the library and includes path respectly. The last
keyword is '\fC%t\fR' which is replaced with the target name of the
compiled binary.
.TP
$TACOMAPATH/cabinets/C_files/*
This directory should contain the TACOMA library and include files.

.SH "SEE ALSO"
.IR meet (3C), folder_rotate (3C)

.SH AUTHOR
Nils Peter Sudmann, University of Tromsoe (nilss@stud.cs.uit.no)
Concept by Dag Johansen (dag@cs.uit.no), Robbert van Renesse
(rvr@cs.cornell.edu) and Fred B. Schneider (fbs@cs.cornell.edu).
