;;; -*- Scheme -*-

(load 'tacoma.o)

(define-macro (folder-pop! bc f)
  `(folder-shift! ,bc ,f 'left 1))

(define-macro (folder-add! bc f data)
  `(folder-shift! ,bc ,f 'left 0 ,data))

(define-macro (folder-push! bc f data)
  `(folder-shift! ,bc ,f 'right 0 ,data))

(define-macro (folder-top bc f)
  `(folder-shift! ,bc ,f 'right 0))

(define stringify-port (open-output-string))
(define-macro (string arg)
  `(begin (write ,arg ,stringify-port)
	  (get-output-string ,stringify-port)))

(define (meet-strerror . code)
  (set! code (if (null? code) meet-error (car code)))
  (if (integer? code)
      (format #f "Local agent returned error ~a" code)
      (case code 
	('OK          "Successful delivery of briefcase")
	('notreached  "First site of HOST folder could not be reached")
	('refused     "Site refused to accept briefcase")
	('nosite      "No site could be found")
	('ag-dead     "Local agent terminated abnormally")
	('ag-notfound "Local agent not found")
	('internal    "Internal failure in the TACOMA system")
	(else         "Unkown returncode")
	)))
    

(provide 'tacoma)