'\"     # CS - begin code section
.de CS
.RS 4
\fC
.ps -1
.nf
.sp
..
'\"     # CE - end code section
.de CE
.fi
\fR
.ps +1
.RE
.sp .5
..
.TH ag_echo 1 "TACOMA 1.1" "Agents"
.SH NAME
ag_echo \- agent which outputs data to a file
.SH SYNOPSIS
\fBag_echo \fIbriefcase\fR
.SH DESCRIPTION
The ag_ehco agent outputs the data found in the DATA folder of
the supplied briefcase to the file named in the OUTPUT
folder. The filename may consist of a path/filename combination,
where relative paths are resolved with the local $TACOMAPATH as anchor.
.SS Note
Currently, this agent is able to write to any file of the local file
system. The intention, however, was to allow agents to access UNIX
device drives (which are visible as files). One should not use it
to store information specific to the TACOMA system. Use the
cabinet primitives for this propose, see
.IR cabinet_create (n).

.SS Folder inputs
.TP
DATA
the data to be written
.TP
OUTPUT
the destination file

.SH EXAMPLE
This piece of Tcl code outputs the string "Hello world!" on the local
console. Notice that we push the name "local" onto the HOST
folder just before the meeting takes place. This achieves two
things. First, the meet is performed on the local machine. Second,
this local meet will not disturb the old contents of the HOST
\fIfolder\fR.
.CS
folder_store my_bc DATA "Hello world!"
folder_store my_bc OUTPUT "/dev/console"
folder_shift my_bc HOST "local" right 0
meet ag_echo my_bc
.CE

.SH SEE ALSO
.IR meet (n), folder_rotate (n)

.SH AUTHOR
Nils Peter Sudmann, University of Tromsoe (nilss@stud.cs.uit.no)
Concept by Dag Johansen (dag@cs.uit.no), Robbert van Renesse
(rvr@cs.cornell.edu) and Fred B. Schneider (fbs@cs.cornell.edu).
